/*
 * Copyright (c) 2011, 2016 Jonas 'Sortie' Termansen.
 *
 * Permission to use, copy, modify, and distribute this software for any
 * purpose with or without fee is hereby granted, provided that the above
 * copyright notice and this permission notice appear in all copies.
 *
 * THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
 * WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
 * ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
 * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
 * ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
 * OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 *
 * uart.h
 * A simple serial terminal driver.
 */

#ifndef SORTIX_UART_H
#define SORTIX_UART_H

namespace Sortix {
namespace UART {

void Init();
void Read(uint8_t* buffer, size_t size);
void Write(const void* buffer, size_t size);
void WriteChar(char c);
void WriteString(const char* str);
__attribute__((format(printf, 1, 2)))
void WriteF(const char* format, ...);
int TryPopChar();

} // namespace UART
} // namespace Sortix

#endif
