/*
 * Copyright (c) 2015 Jonas 'Sortie' Termansen.
 *
 * Permission to use, copy, modify, and distribute this software for any
 * purpose with or without fee is hereby granted, provided that the above
 * copyright notice and this permission notice appear in all copies.
 *
 * THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
 * WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
 * ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
 * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
 * ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
 * OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 *
 * err/vwarnx.c
 * Print an error message to stderr.
 */

#include <err.h>
#include <errno.h>
#include <stdarg.h>
#include <stdio.h>

void vwarnx(const char* fmt, va_list ap)
{
	flockfile(stderr);
	fprintf_unlocked(stderr, "%s", program_invocation_name);
	if ( fmt )
	{
		fputs_unlocked(": ", stderr);
		vfprintf_unlocked(stderr, fmt, ap);
	}
	fputc_unlocked('\n', stderr);
	funlockfile(stderr);
}
