/*
 * Copyright (c) 2012 Jonas 'Sortie' Termansen.
 *
 * Permission to use, copy, modify, and distribute this software for any
 * purpose with or without fee is hereby granted, provided that the above
 * copyright notice and this permission notice appear in all copies.
 *
 * THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
 * WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
 * ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
 * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
 * ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
 * OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 *
 * sys/termmode.h
 * Provides access to the various modes Sortix terminals can operate in.
 */

#ifndef _INCLUDE_SYS_TERMMODE_H
#define _INCLUDE_SYS_TERMMODE_H

#include <sys/cdefs.h>

#include <sortix/termmode.h>

#ifdef __cplusplus
extern "C" {
#endif

int settermmode(int fd, unsigned mode);
int gettermmode(int fd, unsigned* mode);

#ifdef __cplusplus
} /* extern "C" */
#endif

#endif
