/*
 * Copyright (c) 2013, 2014, 2021 Jonas 'Sortie' Termansen.
 *
 * Permission to use, copy, modify, and distribute this software for any
 * purpose with or without fee is hereby granted, provided that the above
 * copyright notice and this permission notice appear in all copies.
 *
 * THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
 * WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
 * ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
 * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
 * ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
 * OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 *
 * pthread/pthread_cond_init.c
 * Initializes a condition variable.
 */

#include <pthread.h>

int pthread_cond_init(pthread_cond_t* restrict cond,
                       const pthread_condattr_t* restrict attr)
{
	pthread_condattr_t default_attr;
	if ( !attr )
	{
		pthread_condattr_init(&default_attr);
		attr = &default_attr;
	}

	pthread_mutex_init(&cond->lock, NULL);
	cond->first = NULL;
	cond->last = NULL;
	cond->clock = attr->clock;

	return 0;
}
